/*----------------------------------------------------------------------------*
* Copyright Statement:                                                       *
*                                                                            *
*   This software/firmware and related documentation ("MediaTek Software")   *
* are protected under international and related jurisdictions'copyright laws *
* as unpublished works. The information contained herein is confidential and *
* proprietary to MediaTek Inc. Without the prior written permission of       *
* MediaTek Inc., any reproduction, modification, use or disclosure of        *
* MediaTek Software, and information contained herein, in whole or in part,  *
* shall be strictly prohibited.                                              *
* MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
*                                                                            *
*   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
* AGREES TO THE FOLLOWING:                                                   *
*                                                                            *
*   1)Any and all intellectual property rights (including without            *
* limitation, patent, copyright, and trade secrets) in and to this           *
* Software/firmware and related documentation ("MediaTek Software") shall    *
* remain the exclusive property of MediaTek Inc. Any and all intellectual    *
* property rights (including without limitation, patent, copyright, and      *
* trade secrets) in and to any modifications and derivatives to MediaTek     *
* Software, whoever made, shall also remain the exclusive property of        *
* MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
* title to any intellectual property right in MediaTek Software to Receiver. *
*                                                                            *
*   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
* representatives is provided to Receiver on an "AS IS" basis only.          *
* MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
* including but not limited to any implied warranties of merchantability,    *
* non-infringement and fitness for a particular purpose and any warranties   *
* arising out of course of performance, course of dealing or usage of trade. *
* MediaTek Inc. does not provide any warranty whatsoever with respect to the *
* software of any third party which may be used by, incorporated in, or      *
* supplied with the MediaTek Software, and Receiver agrees to look only to   *
* such third parties for any warranty claim relating thereto.  Receiver      *
* expressly acknowledges that it is Receiver's sole responsibility to obtain *
* from any third party all proper licenses contained in or delivered with    *
* MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
* releases made to Receiver's specifications or to conform to a particular   *
* standard or open forum.                                                    *
*                                                                            *
*   3)Receiver further acknowledge that Receiver may, either presently       *
* and/or in the future, instruct MediaTek Inc. to assist it in the           *
* development and the implementation, in accordance with Receiver's designs, *
* of certain softwares relating to Receiver's product(s) (the "Services").   *
* Except as may be otherwise agreed to in writing, no warranties of any      *
* kind, whether express or implied, are given by MediaTek Inc. with respect  *
* to the Services provided, and the Services are provided on an "AS IS"      *
* basis. Receiver further acknowledges that the Services may contain errors  *
* that testing is important and it is solely responsible for fully testing   *
* the Services and/or derivatives thereof before they are used, sublicensed  *
* or distributed. Should there be any third party action brought against     *
* MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
* to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
* mutually agree to enter into or continue a business relationship or other  *
* arrangement, the terms and conditions set forth herein shall remain        *
* effective and, unless explicitly stated otherwise, shall prevail in the    *
* event of a conflict in the terms in any agreements entered into between    *
* the parties.                                                               *
*                                                                            *
*   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
* cumulative liability with respect to MediaTek Software released hereunder  *
* will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
* MediaTek Software at issue.                                                *
*                                                                            *
*   5)The transaction contemplated hereunder shall be construed in           *
* accordance with the laws of Singapore, excluding its conflict of laws      *
* principles.  Any disputes, controversies or claims arising thereof and     *
* related thereto shall be settled via arbitration in Singapore, under the   *
* then current rules of the International Chamber of Commerce (ICC).  The    *
* arbitration shall be conducted in English. The awards of the arbitration   *
* shall be final and binding upon both parties and shall be entered and      *
* enforceable in any court of competent jurisdiction.                        *
*---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
*
* $Author: xiaojun.zhu $
* $Date: 2015/08/08 $
* $RCSfile: pi_isdbt_if.h,v $
* $Revision: #4 $
*
*---------------------------------------------------------------------------*/

/** @file pi_isdbt_if.h
*   Demod pi primitive API.
*/
#include "com_defs.h"
#define cMAX_READ_NUM           ccCMD_REG_NUM
#define ERR_BITS_PER_ERR_PKT    27

#ifndef PI_DEMOD_ISDBT_H
#define PI_DEMOD_ISDBT_H
#include "PI_Def.h"
#include "tuner_interface_if.h"

typedef struct
{
	UINT8 u1RegAddr;
	UINT8 u1RegVal;
}DEMOD_I2C_DATA_T;

typedef struct
{
	BOOL  fgValid;    //Indicate if the data is valid(TRUE)
	UINT8 u1TMCCData[8];//TMCC Data 0xB0,0xB2~0xB8
	UINT8 u1Eqqdt; 	   //Eqqdt data
}CHANNEL_INFO_DATA_T;

#define cMAX_TS_CNT     40
enum
{
    ISDBT_DEMOD_STATE_UNLOCK = 0,
		ISDBT_DEMOD_STATE_LOCK,
		ISDBT_DEMOD_STATE_UNKNOWN
};


typedef struct
{
	
	
	//LocK Status
	UINT8  u1AGCLock;
	UINT8  u1DAGCLock;
	UINT8  u1IFSLock;
	UINT8  u1MDLock;
	UINT8  u1TMCCLock;
	UINT8  u1PNCLock;
	UINT8  u1CCILock;
	UINT8  u1SBLock;
	UINT8  u1TMCC_RealIndicator;
	
	//Information
	UINT8  u1RxBW;
	UINT8  u1SysFFTMode;
	UINT8  u1SysGIIntv;
	UINT8  u1FFTMode;
	UINT8  u1GIIntv;
	INT16  u2SymbolBoundary;
	UINT8  u1LayAMode;
	UINT8  u1LayACR;
	UINT8  u1LayAIL;
	UINT8  u1LayASegNum;
	UINT8  u1LayBMode;
	UINT8  u1LayBCR;
	UINT8  u1LayBIL;
	UINT8  u1LayBSegNum;
	UINT8  u1LayCMode;
	UINT8  u1LayCCR;
	UINT8  u1LayCIL;
	UINT8  u1LayCSegNum;
	UINT8  u1PartRecp;
	UINT8  u1SpecInv;
	
	//Parameters
	INT16  s2IntCFO;         // Integer Frequency Offset
	INT16  s2FrcCFO;         // Integer Frequency Offset
	INT64  s4TotalCFO;       // Total Frequency Offset
	INT32  s4TimingCFO;      // Timing Offset
	INT32  s4IntpoRatio;
	UINT16 u2CommPhase;      // Common Phase
	UINT8	 u1CCIState;       // CCI status
	INT16  s2FTTCFO;         // FTT estimate frequency offset
	INT16  s2FTTTFO;         // FTT estimate timing offset
	INT16	 s2FTTCommPhase;   // FTT estimate common phase
	UINT8	 u1FTTFreqLfFSM;   // FTT frequency loop-filter FSM
	INT32	 s4FTTLFCFO;       // FTT loop-filter frequency offset 
	UINT8	 u1FTTTimgLfFSM;   // FTT timing loop-filter FSM
	INT16	 s2FTTLfTFO;       // FTT loopfilter timing offset
	UINT8	 u1CEType;         // CE type
	UINT8	 u1SNRInfo;        // SNR related information
	UINT8  u1SNRGroupSize;   // SNR Group Size
	UINT16 u2HierATotalPkt;  // Hier A Total Packet
	UINT32 u4HierAErrBit;    // Hier A Error Bit
	UINT16 u2HierAUnCorrPkt; // Hier A Correlation Packet
	UINT16 u2HierBTotalPkt;  // Hier A Total Packet
	UINT32 u4HierBErrBit;    // Hier A Error Bit
	UINT16 u2HierBUnCorrPkt; // Hier A Correlation Packet
	UINT16 u2HierCTotalPkt;  // Hier A Total Packet
	UINT32 u4HierCErrBit;    // Hier A Error Bit
	UINT16 u2HierCUnCorrPkt; // Hier A Correlation Packet
	
	UINT16 u2ITER_HierXTotalPkt;  // ITER Hier X Total Packet
 	UINT32 u4ITER_HierXErrBit;    // ITER Hier X Error Bit
 	UINT16 u2ITER_HierXUnCorrPkt; // ITER Hier X Correlation Packet
  
	UINT8  u1TEQState;       // TEQ State
	UINT8	 u1LPNCState;      // LPNC State
	UINT8	 u1GICState;       // GIC State
	UINT8  u1DOPIdx1;        // DOP Indicator 1 and Corresponding Distance
	UINT8  u1DOPDist1;
	UINT8  u1DOPIdx2;        // DOP Indicator 2 and Corresponding Distance
	UINT8  u1DOPDist2;
	UINT8	 u1CCIIdx;         // CCI Indicator
	UINT8	 u1PhaseNoise;     // Phase Noise Indicator
	UINT8  u1TMCCSwitch;
	UINT8  u1TMCCStatus;
	UINT8  u1TMCCValid; 
	UINT8  u1TMCCEmgFlag;
	UINT16 u2NoiseWeight;
	INT16  s2CommonPhase;
	UINT32 u4PhaseVariance;
	INT16  s2MaxPhase;
	UINT8  u1PhaseVarDone;
	UINT16 u2PheWatchDuration;
	UINT32 u4PheThdVariance;
	UINT16 u2SNREstSym;
	UINT32 u4SNREstAR;
	UINT8  u1SNRBadPilotCnt0;
	UINT8  u1SNRBadPilotCnt1;
	UINT8  u1SNRBadPilotCnt2;
	UINT16 u2CSISymWeight;
	UINT32 u4CSISymNoiseARAcc;
	UINT32 u4CSISymNoiseAcc;
	UINT32 u4CSISymNoiseCnt;
	UINT32 u4CSICnt;
	UINT32 u4CISMidNoiseStage7;
	UINT32 u4CISMidNoiseStage8;
	UINT32 u4CISMidNoiseStage9;
	UINT32 u4CISMidNoiseStageA;
	UINT16 u2NoiseTheCnt;
	INT32  s4CVE_First_AR_RESULT;
	UINT32 u4CVE_First_AR_DIST;
	INT32  s4CVE_Second_AR_RESULT;
	UINT32 u4CVE_Second_AR_DIST;
	INT32  s4CVE_First_AR_Instant_Max;
	INT32  s4CVE_First_AR_Instant_Min;
	UINT8  u1PGAGain;
	INT16  s2MagRef;
	
	UINT8  u1DiffMD_En;
	UINT8  u1DiffMD_GI;
	UINT8  u1DiffConfrim_Sta_thd;
	UINT8  u1DiffInvalid_Sta_thd;
	UINT8  u1DiffMD_Done;
	UINT8  u1DiffMD_CB_Result;
	UINT32 u2DiffMD_SYMSTARTPT;
	
	UINT16 u2LPNC_Delta_Phase;
	UINT16 u2LPNC_Max_Phase;
	UINT32 u4LPNC_Phase_Var; 
	UINT32 u4LPNC_Phase_Var_Thd;
	UINT16 u2LPNC_Flag_Phase_Noise;
	UINT8  u1LPNC_Watch_Duration;
	UINT8  u1LPNC_Alpha_Phase;
	UINT8  u1LPNC_Enable;
	UINT8  u1LPNC_Doing;
	UINT8  u1GIC_Sample_Error;
	UINT8  u1GIC_Enable;
	UINT8  u1TEQ_Enable;
	UINT8  u1TEQ_Echo_Type;
	UINT8  u1TEQ_Echo_Num;
	UINT8  u1TEQ_Ready;
	UINT8  u1TEQ_Filter_Type;
	UINT8  u1TEQ_Delay_Only_Mode;
	INT16  s2LDAGC_ST_CH_Variance;
	INT16  s2LDAGC_MT_CH_Variance;
	INT16  s2LDAGC_LT_CH_Variance;
	UINT8  uIFFT_Scale;
	/*****************************MTK40721******************************************/
	UINT16  s2ANIR_CCI_STRENGTH_Variance;
	
	UINT8  u1SB_BUFFER_PAKET_Variance;
	UINT16 u2SB_BALANCE_Variance;
	/*****************************MTK40721******************************************/
	
}ISDBT_DEMOD_CTX_T;


typedef struct _DEMOD_CTX_T
{
	// Hardware Configure
    UINT8           I2cAddress;
	//    INT32           Frequency ;             /* carrier frequency (in Hz)   */
    UINT8           fgEn24MClk;
    UINT8           ucEnFpga;
    UINT8           u1Bw;
    UCHAR           ucConnType;
    BOOL            fgDebugHstCmd;
    UINT8           u1ReAcqCnt;
    UINT8           u1ReAcqCnt1;
    BOOL            fgClrSram;
    //CHANNEL_INFO_DATA_T ch_info[63];//63 channels CH7~CH69 
    UINT32          u4Per;
    UINT32          u4Ber;
    UINT32          u4Freq;
    UINT32          u4LayABER;
    UINT32          u4LayAPER;
    UINT32          u4LayBBER;
    UINT32          u4LayBPER;	
    UINT32          u4LayCBER;
    UINT32          u4LayCPER;	
    UINT32          u4IterLayBER;
    UINT32          u4IterLayPER;
	UINT32          u4IterLayBER_SZ;	   //nim.dtd s show BER which is cal. by DVBT method
    BOOL            fgLowIF;			   // 0:44MHz (Default), 1:Low IF (6MHz)
	// Status
    UINT8           u1earlybreak;
    UINT8           u1Ver1;
    UINT8           u1Ver0;
    UINT8           u1Fft;
    UINT8           u1GI;
    UINT8           u1CR;	
    UINT8           u1LayACR;
    UINT8           u1LayBCR;
    UINT8           u1LayCCR;
    UINT8           u1Mod;
    UINT8           u1LayAMod;	
    UINT8           u1LayBMod; 
    UINT8           u1LayCMod;
    UINT8           u1LayNum;
    UINT8           u1LayASegNum;
    UINT8           u1LayBSegNum;
    UINT8           u1LayCSegNum;
    UINT32          u4LayADataRate;
    UINT32          u4LayBDataRate;
    UINT32          u4LayCDataRate;
    UINT8           ucSramSize;
    UINT8           u1Hier;
    UINT8           u1HpLp;
    UINT8           u1LpCR;
    UINT8           u1HpCR;
    UINT8           u1Indepth;
    INT16           s2Ifo;
    INT16           s2Ffo;
    INT32           s4Cfo;
    UINT8           u1Si;
    UINT8           m_TunerType;
    UCHAR           m_TunerMode; // momo, 061116, for silicon tuner
    UINT16          u2CellId;
    INT8            s1IfAgc;
    UINT8           u1ControlStatus;
    BOOL            fgAgcLock;
    UINT8           ucMdFftMode;
    UINT8           ucLastDemodStatus;
    BOOL            fgTpsLock;
    BOOL            fgTsLock;
    UINT8           u1Rssi;
    INT16           s2Snr;   // SNR*512
    UINT8           s2snr_cc; //SNR coefficient of correction,lei111014;
    UINT32          u4ErrorPkt;
    UINT32          u4TotalPkt;
    UINT32          u4CorrBit;
	//lei140701
    UINT32          u4UecPktErr;//Acc error packet
    UINT32          u4UecErrCnt;//unlock counter
    UINT16          u2VdTotBit;
    UINT16          u2VdErrBit;
    BOOL            fgDemodReset;
    UINT8           u1UpChkCnt;
    UINT8           u1UpNakCnt;
    UINT8           u1UpMisCnt;
    INT16           s2SldPraRfAgc;  //For MT5135 SLD. Hui @ 20100412.
    INT16           s2SldPraIfAgc;
	UINT8           ucSldPraState;
    UINT16          u2RfAgcRssi;
    UINT8           ucSldPraGainIdx;
    INT16           s2SldPraOut;
    // RF AGC
    INT8            m_s1AciPow;
    INT8            m_s1InbPow;
    UINT8           ucTsIfFormat;
    UINT8           ucTsIfCtrl;
    UINT8           ucTsIfRate;
	
    UINT8           u1ChSearchMode;
    BOOL            fgSelectANIR;
    UINT8           u1MdMode;
    UINT8           u1TpsCr;
    UINT8           u1TpsCons;
    UINT8           u1TpsHier;
    INT8            s1FreqBias40khz;
	
    UINT8           u1TunerAcqType; // for SDAL, tune freq only or tune Demod only
    ITUNER_CTX_T*   psTunerCtx;
	
    //void            *psI2cCtx;
    HANDLE_T          hHostCmdLock;     // Semaphore
    HANDLE_T          hRegLock;         // Semaphore
    HANDLE_T          hLogLock;         // Semaphore
    BOOL              fgDemodInitFlag;
    HANDLE_T          hDemodAcq;        // Semaphore
    //THREAD_T        t_monitor_thread;
    BOOL            fgMonitorThreadRunning;
    INT32           i4BerTh;
	
    UINT8           u1PecFlag;
    UINT16          u2PecRefreshTime;
    UINT32          u4PecObserveTime;
    UINT8           u1PecErrSec;    
    BOOL            fgPecReady;
	
	////////ISDBT related/////////////////////
	
    ISDBT_DEMOD_CTX_T sISDBTCtx;
	
} DEMOD_CTX_T;


/*********** Register Addr. *************************************/
#define ISDBT_REG_uP_Ctrl      (UINT16) 0x00
#define ISDBT_REG_uP_IRA_H     (UINT16) 0x24
#define ISDBT_REG_uP_IRA_L     (UINT16) 0x25
#define ISDBT_REG_uP_IRData    (UINT16) 0x28
#define ISDBT_REG_uP_CMDR_CFG  (UINT16) 0x07
#define ISDBT_REG_uP_GP_REG00  (UINT16) 0x08
#define ISDBT_REG_uP_GP_REG01  (UINT16) 0x09
#define ISDBT_REG_uP_GP_REG02  (UINT16) 0x0A
#define ISDBT_REG_uP_GP_REG03  (UINT16) 0x0B
#define ISDBT_REG_uP_GP_REG04  (UINT16) 0x0C
#define ISDBT_REG_uP_GP_REG05  (UINT16) 0x0D
#define ISDBT_REG_uP_GP_REG06  (UINT16) 0x0E
#define ISDBT_REG_uP_GP_REG07  (UINT16) 0x0F

#define ISDBT_REG_RFA4A0       (UINT16) 0x4A0
#define ISDBT_REG_RISCIF_CFG   (UINT16) 0x4A4
#define ISDBT_REG_RISCIF_WDATA (UINT16) 0x4B0
#define ISDBT_REG_RISCIF_CTRL  (UINT16) 0x4B4
#define ISDBT_REG_RISCIF_RDATA (UINT16) 0x4B8
#define ISDBT_REG_RISCIF_STAT  (UINT16) 0x4BC

#define ISDBT_REG_RSICIF_CMD0  (UINT16) 0x4C0
#define ISDBT_REG_RSICIF_CMD1  (UINT16) 0x4C1
#define ISDBT_REG_RSICIF_CMD2  (UINT16) 0x4C2
#define ISDBT_REG_RSICIF_CMD3  (UINT16) 0x4C3
#define ISDBT_REG_RSICIF_CMD4  (UINT16) 0x4C4
#define ISDBT_REG_RSICIF_CMD5  (UINT16) 0x4C5
#define ISDBT_REG_RSICIF_CMD6  (UINT16) 0x4C6
#define ISDBT_REG_RSICIF_CMD7  (UINT16) 0x4C7
#define ISDBT_REG_RSICIF_RSP0  (UINT16) 0x4C8
#define ISDBT_REG_RSICIF_RSP1  (UINT16) 0x4C9
#define ISDBT_REG_RSICIF_RSP2  (UINT16) 0x4CA
#define ISDBT_REG_RSICIF_RSP3  (UINT16) 0x4CB
#define ISDBT_REG_RSICIF_RSP4  (UINT16) 0x4CC
#define ISDBT_REG_RSICIF_RSP5  (UINT16) 0x4CD
#define ISDBT_REG_RSICIF_RSP6  (UINT16) 0x4CE
#define ISDBT_REG_RSICIF_RSP7  (UINT16) 0x4CF
#define ISDBT_REG_uP_PNGP_H    (UINT16) 0x2C
#define ISDBT_REG_uP_PNGP_L    (UINT16) 0x2D
#define ISDBT_REG_uP_LPA_H     (UINT16) 0x2E
#define ISDBT_REG_uP_LPA_L     (UINT16) 0x2F
#define ISDBT_REG_I2C_Cfg      (UINT16) 0x44
#define ISDBT_REG_I2C_Deglitch (UINT16) 0x45
#define ISDBT_REG_I2C_Pullup_Del (UINT16) 0x46
#define ISDBT_REG_I2C_IF_Cfg   (UINT16) 0x47

/******************				   ISDBT				   *********************/
//#define DEFAULT_I2C_ADDR        0x82
#ifdef CC_SUPPORT_STR
VOID ISDBT_CloseClk(DEMOD_CTX_T *psDemodCtx);
VOID ISDBT_OpenClk(DEMOD_CTX_T *psDemodCtx);
#endif

#endif

