/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
 *
 * $Author$
 * $Date  $
 * $RCSfile: drv_hdmi.h,v $
 * $Revision$
 *
 *---------------------------------------------------------------------------*/
#ifndef _DRV_HDMI2_H_
#define _DRV_HDMI2_H_

#include "typedef.h"
#include "x_timer.h"

#define HDMI_RX_HDCP_FINISH (1)
#define HDMI_RX_HDCP_START (1<<1)
#define HDMI_RX_HDCP_AKE_INIT (1<<18)
#define HDMI_RX_HDCP_SKE_INIT (1<<19)

#define HDMI_RX_NEW_AVI (1<<16)
#define HDMI_RX_NEW_SP (1<<17)
#define HDMI_RX_NEW_AUD (1<<18)
#define HDMI_RX_NEW_MPEG (1<<19)
#define HDMI_RX_NEW_UNREC (1<<20)
#define HDMI_RX_NEW_CP (1<<23)
#define HDMI_RX_INVALID_AVI (1<<28)

#define HDMI_RX_NEW_HDR_0x86 (1<<6)
#define HDMI_RX_NEW_HDR_0x87 (1<<7)

#define HDMI_RX_AAC_MUTE (1<<6)
#define HDMI_RX_NEW_ACP (1<<10)
#define HDMI_RX_NEW_VSIF (1<<22)

#define HDMI_RX_NEW_ISRC1 (1<<2)
#define HDMI_RX_NEW_ISRC2 (1<<3)
#define HDMI_RX_NEW_GCP   (1<<4)
#define HDMI_RX_NEW_HF_VSIF (1<<9)

#define HDMI_RX_HDCP2X_INT_AUTH_DONE      (1)
#define HDMI_RX_HDCP2X_INT_AKE_SENT_RCVD  (1<<18)

#define HDMI_RST_ALL    1
#define HDMI_RST_EQ        2
#define HDMI_RST_DEEPCOLOR    3
#define HDMI_RST_FIXEQ        4
#define HDMI_RST_RTCK        5
#define HDMI_RST_DIGITALPHY 6

#define HDMI_AUD_Length_Unknown      0
#define HDMI_AUD_Length_16bits      1
#define HDMI_AUD_Length_17bits      2
#define HDMI_AUD_Length_18bits      3
#define HDMI_AUD_Length_19bits      4
#define HDMI_AUD_Length_20bits      5
#define HDMI_AUD_Length_21bits      6
#define HDMI_AUD_Length_22bits      7
#define HDMI_AUD_Length_23bits      8
#define HDMI_AUD_Length_24bits      9

#define HDMI_ENABLE_EQ_TRACKING_6G 1

#define HDMI_HDR_METADATA_LENGTH 24
#define HDMI_INVALID_HDR_EOTF_VALUE 0xff

enum
{
    HDMI_3D_Structure_FramePacking=0,
    HDMI_3D_Structure_FieldAlternative,
    HDMI_3D_Structure_LineAlternative,
    HDMI_3D_Structure_SideBySideFull,
    HDMI_3D_Structure_LDepth,
    HDMI_3D_Structure_LDepthGraph,
    HDMI_3D_Structure_TopBottom,
    HDMI_3D_Structure_SideBySideHalf=8,
    HDMI_3D_Structure_Unknow
};

enum
{
    HDMI_NOSIGNAL_STATE=0,
    HDMI_WAIT_CONNECT_STATE,
    HDMI_WAIT_STABLE_STATE,
    HDMI_STABLE_STATE
};
typedef enum
{
    HDMI_RX_MODE_DVI,
    HDMI_RX_MODE_HDMI1X,
    HDMI_RX_MODE_HDMI2X,
    HDMI_RX_MODE_MHL
}HdmiRxMode_t;

typedef enum eHDMI_SWITCH_NO {
    HDMI_SWITCH_INIT = 0,
    HDMI_SWITCH_1,
    HDMI_SWITCH_2,
    HDMI_SWITCH_3,
    HDMI_SWITCH_4,
    HDMI_SWITCH_MAX
}E_HDMI_SWITCH_NUM;

typedef enum
{
    HDMI_RX_PORT_Init=0,
    HDMI_RX_PORT_1,
    HDMI_RX_PORT_2,
    HDMI_RX_PORT_3,
    HDMI_RX_PORT_MAX
}HdmiRxPort;

typedef enum
{
    HDMI_RX_INPUT_TYPE_NONE,
    HDMI_RX_INPUT_TYPE_HDMI,
    HDMI_RX_INPUT_TYPE_MHL,
}HdmiRxInputType_t;


typedef enum
{
    HDMI_RX_CLRSPC_UNKNOW,
    HDMI_RX_CLRSPC_YC444_601,
    HDMI_RX_CLRSPC_YC422_601,
    HDMI_RX_CLRSPC_YC420_601,

    HDMI_RX_CLRSPC_YC444_709,
    HDMI_RX_CLRSPC_YC422_709,
    HDMI_RX_CLRSPC_YC420_709,

    HDMI_RX_CLRSPC_XVYC444_601,
    HDMI_RX_CLRSPC_XVYC422_601,
    HDMI_RX_CLRSPC_XVYC420_601,

    HDMI_RX_CLRSPC_XVYC444_709,
    HDMI_RX_CLRSPC_XVYC422_709,
    HDMI_RX_CLRSPC_XVYC420_709,

    HDMI_RX_CLRSPC_sYCC444_601,
    HDMI_RX_CLRSPC_sYCC422_601,
    HDMI_RX_CLRSPC_sYCC420_601,

    HDMI_RX_CLRSPC_Adobe_YCC444_601,
    HDMI_RX_CLRSPC_Adobe_YCC422_601,
    HDMI_RX_CLRSPC_Adobe_YCC420_601,
    HDMI_RX_CLRSPC_YUV_NO_DATA,
    HDMI_RX_CLRSPC_Adobe_sYUV,
    HDMI_RX_CLRSPC_Reserved,

    HDMI_RX_CLRSPC_RGB,
    HDMI_RX_CLRSPC_Adobe_RGB,

    HDMI_RX_CLRSPC_BT_2020_RGB_non_const_luminous,
    HDMI_RX_CLRSPC_BT_2020_RGB_const_luminous,

    HDMI_RX_CLRSPC_BT_2020_YCC444_non_const_luminous,
    HDMI_RX_CLRSPC_BT_2020_YCC422_non_const_luminous,
    HDMI_RX_CLRSPC_BT_2020_YCC420_non_const_luminous,

    HDMI_RX_CLRSPC_BT_2020_YCC444_const_luminous,
    HDMI_RX_CLRSPC_BT_2020_YCC422_const_luminous,
    HDMI_RX_CLRSPC_BT_2020_YCC420_const_luminous

}HdmiRxClrSpc_t;

typedef enum
{
    HDMI_RX_BIT_DEPTH_8_BIT,
    HDMI_RX_BIT_DEPTH_10_BIT,
    HDMI_RX_BIT_DEPTH_12_BIT,
    HDMI_RX_BIT_DEPTH_16_BIT
}HdmiRxBitDepth_t;

typedef enum
{
    HDMI_RX_RGB_FULL,
    HDMI_RX_RGB_LIMT,
    HDMI_RX_YCC_FULL,
    HDMI_RX_YCC_LIMT
}HdmiRxRange_t;
typedef enum
{
    HDMI_RX_OVERSCAN=1,
    HDMI_RX_UNDERSCAN
}HdmiRxScanInfo_t;

typedef enum
{
    HDMI_RX_ASPECT_RATIO_4_3=1,
    HDMI_RX_ASPECT_RATIO_16_9
}HdmiRxAspectRatio_t;

typedef enum
{
    HDMI_RX_AFD_SAME=8,
    HDMI_RX_AFD_4_3,
    HDMI_RX_AFD_16_9,
    HDMI_RX_AFD_14_9
}HdmiRxAFDInfo_t;

typedef enum
{
    HDMI_RX_ITC_GRAPHICS=0,
    HDMI_RX_ITC_PHOTO,
    HDMI_RX_ITC_CINEMA,
    HDMI_RX_ITC_GAME
}HdmiRxITCInfo_t;

typedef enum
{
    HDMI_RX_HDCP_LINK_VER_NONE,
    HDMI_RX_HDCP_LINK_VER_HDCP1X,
    HDMI_RX_HDCP_LINK_VER_HDCP22,
}HdmiRxHdcpLinkVer_t;

typedef enum
{
    HDMI_RX_HDCP2_STATUS_OFF=0x0,
    HDMI_RX_HDCP2_STATUS_AUTH_DONE =0x1,
    HDMI_RX_HDCP2_STATUS_AUTH_FAIL=0x2,
    HDMI_RX_HDCP2_STATUS_CCHK_DONE=0x4,
    HDMI_RX_HDCP2_STATUS_CCHK_FAIL=0x8,
    HDMI_RX_HDCP2_STATUS_AKE_SENT_RCVD=0x10,
    HDMI_RX_HDCP2_STATUS_SKE_SENT_RCVD=0x20,
    HDMI_RX_HDCP2_STATUS_CERT_SENT_RCVD=0x40,
    HDMI_RX_HDCP2_STATUS_DECRYPT_SUCCESS=0x80,
    HDMI_RX_HDCP2_STATUS_DECRYPT_FAIL=0x100
}HdmiRxHdcp2Status_t;

typedef enum
{
    HDMI_RX_HDCP1_STATUS_OFF =0x0,
    HDMI_RX_HDCP1_STATUS_AUTH_DONE =0x1,
    HDMI_RX_HDCP1_STATUS_AUTH_FAIL =0x2,
    HDMI_RX_HDCP1_STATUS_DECRYPT_SUCCESS=0x4,
    HDMI_RX_HDCP1_STATUS_DECRYPT_FAIL=0x8
}HdmiRxHdcp1Status_t;

typedef enum
{
    HDMI_RX_AUDIO_FS_24KHZ,
    HDMI_RX_AUDIO_FS_32KHZ,
    HDMI_RX_AUDIO_FS_44_1KHZ,
    HDMI_RX_AUDIO_FS_48KHZ,
    HDMI_RX_AUDIO_FS_88_2KHZ,
    HDMI_RX_AUDIO_FS_96KHZ,
    HDMI_RX_AUDIO_FS_176_4KHZ,
    HDMI_RX_AUDIO_FS_192KHZ,
    HDMI_RX_AUDIO_FS_768KHZ
}HdmiRxAudioFs_t;

typedef enum
{
    HDMI_TMDS_CLOCK_UNKNOW,
    HDMI_TMDS_CLOCK_25,
    HDMI_TMDS_CLOCK_25_35,
    HDMI_TMDS_CLOCK_35_40,
    HDMI_TMDS_CLOCK_40_50,
    HDMI_TMDS_CLOCK_50_80,
    HDMI_TMDS_CLOCK_80_100,
    HDMI_TMDS_CLOCK_100_120,
    HDMI_TMDS_CLOCK_120_140,
    HDMI_TMDS_CLOCK_140_200,
    HDMI_TMDS_CLOCK_200_300
}HdmiTmdsClkRate_t;

typedef enum
{
    MHL_TMDS_CLOCK_UNKNOW,
//    MHL_TMDS_CLOCK_25_37,
    MHL_TMDS_CLOCK_25_35,
    MHL_TMDS_CLOCK_35_37,
//    MHL_TMDS_CLOCK_37_50,
    MHL_TMDS_CLOCK_37_40,
    MHL_TMDS_CLOCK_40_50,
    MHL_TMDS_CLOCK_50_60,
    MHL_TMDS_CLOCK_60_67,
    MHL_TMDS_CLOCK_67_75
}MhlTmdsClkRate_t;


typedef enum
{
    HDMI_AUDIO_FIFO_NORMAL= 0x1,
    HDMI_AUDIO_FIFO_UNDERRUN= 0x2,
    HDMI_AUDIO_FIFO_OVERRUN= 0x4
}HdmiAudFifoStatus_t;

typedef enum
{
    HDMI_TMDS_DATA_CHANNEL_0,
    HDMI_TMDS_DATA_CHANNEL_1,
    HDMI_TMDS_DATA_CHANNEL_2
}HdmiTmdsDataChannel_t;

typedef enum
{
    HDMI_INFO_FRAME_UNKNOWN,
    HDMI_INFO_FRAME_ID_AVI,
    HDMI_INFO_FRAME_ID_SPD,
    HDMI_INFO_FRAME_ID_AUD,
    HDMI_INFO_FRAME_ID_MPEG,
    HDMI_INFO_FRAME_ID_UNREC,
    HDMI_INFO_FRAME_ID_ACP,
    HDMI_INFO_FRAME_ID_VSI,
    HDMI_INFO_FRAME_ID_ISRC0,
    HDMI_INFO_FRAME_ID_ISRC1,
    HDMI_INFO_FRAME_ID_GCP,
    HDMI_INFO_FRAME_ID_HFVSI,
    HDMI_INFO_FRAME_ID_HDR_0x86,
    HDMI_INFO_FRAME_ID_HDR_0x87
}HdmiInfoFrameID_t;


enum
{
    HDMI_SPD_NONE_CHG,
    HDMI_SPD_CLEAR,//no SPD
    HDMI_SPD_CHG_TOUP,
    HDMI_SPD_CHG_TONONUP,
    HDMI_SPD_CHG_TOSV,
    HDMI_SPD_CHG_TONONSV,
};

enum
{
    HDMI_SPD_NONE_STATUS,
    HDMI_SPD_UP_UNDET,//Without specific pattern
    HDMI_SPD_UP_DETED,//With specific pattern
    HDMI_SPD_SV_UNDET,
    HDMI_SPD_SV_DETED,
};

typedef enum {
    HDMI_HDCP1X,
    HDMI_HDCP2X
}HDMI_HDCP_KEY_CHECK_MODE_T;

typedef struct
{
    HdmiRxClrSpc_t clrSpc;
    HdmiRxRange_t range;
}HdmiVideoInfo_t;

typedef struct
{
    BOOL fgItc;
    HdmiRxITCInfo_t ItcContent;
}HdmiItcInfo_t;

typedef struct
{
    UINT8 HDMI_3D_Enable;
    UINT8 HDMI_3D_Video_Format;
    UINT8 HDMI_3D_Structure;
    UINT8 HDMI_3D_EXTDATA;
}HdmiVideo3DInfo_t;

typedef struct
{
    UINT8 layout;
    UINT8 dsd;
    UINT8 hbrA;
    HdmiRxAudioFs_t audioFs;
}HdmiRxAudioFormat_t;

typedef struct
{
    UINT8 u1CategoryCode;
    UINT8 u1WordLength;
    UINT8 u1b1;
    UINT8 u1b2;
    UINT8 u1b3;
    BOOL fgCopyRight;
    BOOL fgIsPCM;
}HdmiRxAudioChannelStatus_t;

typedef struct
{
    BOOL fgIsAudMute;
    HdmiRxAudioFormat_t audFormat;
    HdmiRxAudioChannelStatus_t chlStatus;
}HdmiRxAudioInfomation_t;

typedef struct
{
    HdmiInfoFrameID_t u1InfoID;
    UINT8 u1InfoData[32];
}HdmiRxInfo_t;

typedef struct
{
    UINT32 u4Header;
    UINT32 au4VdrName[2];//Vendor Name Chacter VN1 TO VN8, 8 bytes.
    UINT32 au4PrdDspt[4];//Product Description Chacter PD1 TO PD16,16 bytes.
    UINT8 u1SrcInfo;
}HdmiSpdParse_t;

typedef struct
{
    UINT8 u1LastScramblingOn;
    UINT8 u1ScramblingOn;
    UINT8 u1ClkRatio;
}HdmiScdcStatus_t;

typedef struct
{
    UINT8 au1HdrMetadata[HDMI_HDR_METADATA_LENGTH];
}HDMI_HDR_METADATA;

#ifdef CC_HDMI_POH_SUPPORT
typedef enum
{
    HDMI_POH_STATE_IDLE,
    HDMI_POH_STATE_WAIT_CONNECT,
    HDMI_POH_STATE_CONNECTED
}E_HDMI_POH_STATE;

typedef struct _HDMI_POH_CONFIG_T
{
    UINT8 u1PortId; //Driver port ID
    UINT8 fgEnable; //POH enable
    INT32 i4GpioPwrEn; //POH power enable gpio
    INT32 i4GpioPohDet; //POH device detect gpio
    INT32 i4GpioOcpDet; //POH over current detect gpio
}HDMI_POH_CONFIG_T;
#endif

typedef enum
{
    HDMI_RX_HDCP2X_AUTH_OFF=0,
    HDMI_RX_HDCP2X_AUTH_AKE_SENT_RCVD,
    HDMI_RX_HDCP2X_AUTH_AUTH_DONE
}HDMI_RX_HDCP2X_AUTH_STATUS_T;

typedef struct
{
    UINT8 _bHdmiCmd;
    UINT8 _bHDMIState;
    UINT8 _bHDMIStateOld;
    UINT8 _bHDMIPower5vStatus;
    UINT8 _bHdmiPlug;
    UINT8 _bUnplugFlag;
    UINT8 _bHDMIAvMute;
    UINT16 _bHDMIRxBaseAddr;
    UINT16 _bHDMIAnaBaseAddr;
    UINT8 _bHDMICkdt;
    UINT8 _bHDMIScdt;
    UINT8 _bHDMIScdtLose;
    UINT8 _bHDMIHpdTimerCnt;
    UINT8 _bHDMIHdcp1xGood;
    UINT8 _bHDMIHdcp2xGood;
    UINT8 _bSCDTdelay;
    UINT8 _bHDMIResStableCnt;
    UINT8 _bHDMIResUnStableCnt;
    UINT8 _bIs422;
    UINT8 _bHDMIFastSW;
    UINT8 _bResv1;
    UINT8 _bNoVsiCount;
    UINT8 _bNoSpdCount;
    UINT8 _bNo4KPsCount;
    UINT8 _bHDMIEqTracking;
    UINT8 _bHDMIEqCh0;
    UINT8 _bHDMIEqCh1;
    UINT8 _bHDMIEqCh2;
    UINT16 _bHDMIEqTrackingWaitCnt;
    UINT16 _bHDMIEqTrackingStableCnt;
    UINT32 _dwHDMIClkKhz;
    BOOL _fgHDMI40xMode;
    UINT8 _bSpdStatus;
    UINT8 _bSpdUpStaChg;
    UINT8 _b4KPsStatus;
    UINT8 _bNoAcpCount;
    UINT8 _bHdrEOTF;
    BOOL _fgFirstAnaSetting;
    HAL_TIME_T _rHdrReceiveTime;
    HAL_TIME_T _rHDMIEqTrackingStart;
#ifdef CC_HDMI_POH_SUPPORT
    E_HDMI_POH_STATE _ePohState;
#endif

    HdmiRxMode_t _HdmiMode;
    HdmiRxInputType_t _ConnectType;
    HdmiRxClrSpc_t _HdmiClrSpc;
    HdmiRxBitDepth_t _HdmiDepth;
    HdmiRxRange_t _HdmiRange;
    HdmiRxScanInfo_t _HdmiScan;
    HdmiRxAspectRatio_t _HdmiAspect;
    HdmiRxAFDInfo_t    _HdmiAFD;
    HdmiItcInfo_t     _HdmiITC;
    HdmiVideo3DInfo_t _Hdmi3DInfo;
    HdmiRxHdcpLinkVer_t _HdcpLinkVer;
    HdmiRxHdcp1Status_t _Hdcp1xState;
    HdmiRxHdcp2Status_t _Hdcp2xState;

    HdmiScdcStatus_t _ScdcInfo;
    HdmiRxInfo_t _AviInfo;
    HdmiRxInfo_t _SpdInfo;
    HdmiRxInfo_t _AudInfo;
    HdmiRxInfo_t _MpegInfo;
    HdmiRxInfo_t _UnrecInfo;
    HdmiRxInfo_t _Hdr87Info;
    HdmiRxInfo_t _Hdr86Info;
    HdmiRxInfo_t _AcpInfo;
    HdmiRxInfo_t _VsiInfo;
    HdmiRxInfo_t _Isrc0Info;
    HdmiRxInfo_t _Isrc1Info;
    HdmiRxInfo_t _GcpInfo;
    HdmiRxInfo_t _HfVsiInfo;
    HdmiRxAudioInfomation_t _AudStatus;
    HDMI_HDR_METADATA _rHdrMetadata;
    BOOL _fgFirstEnterAuthDone;
    UINT8 _bHDMIHDCP2xHandlerCnt;
    UINT8 _bHDMIHDCP2xErrCnt;
    HDMI_RX_HDCP2X_AUTH_STATUS_T _eHdcp2xAuthStatus;
} HdmiRxObject_t;

typedef struct HDMI_PORT_INFO_T
{
    UINT8 u1UIPortId;           ///< HDMI UI Port ID, Port ID should start from 1 which corresponds to HDMI "port 1".
    UINT8 u1DriverPortId;       ///< HDMI  Driver Port ID
    BOOL bEnable;               ///<HDMI Driver Port Enable
    BOOL bCECSupport;           ///<CEC Support
    BOOL bARCSupport;           ///<ARC Support
} HDMI_PORT_INFO_T;

typedef struct HDMI_PORTS_INFO_T
{
    UINT8 u1PortNum;           ///< the number of HDMI ports in the system
    HDMI_PORT_INFO_T rHdmiPortInfo[HDMI_SWITCH_MAX-1];
} HDMI_PORTS_INFO_T;

typedef void (*DRIVER_HDMI_ACP_CHG_CB)(UINT8 u1HdmiAcp,void* pvTag);
#define HDMI_MAX_PHYCIAL_PORT_NUM HDMI_SWITCH_3 //define it for each SOC

extern HdmiRxPort eHDMICurrSwitch;
extern void vHDMIHPDHigh(HdmiRxPort eSwitch);
extern void vHDMIHPDLow(HdmiRxPort eSwitch);
extern UINT8 bHDMIPort5VStatus(HdmiRxPort ePort);
extern void vHDMI2Init(void);
extern void vHDMI2RxInit(HdmiRxPort ePort);
extern void vHDMI2HwInit(HdmiRxPort ePort);
extern void vHDMI2MainLoop(void);
extern void vHDMI2TMDSCTRL(HdmiRxPort ePort,BOOL bOnOff);
extern void vHDMI2DDCBusCTRL(HdmiRxPort ePort,BOOL bOnOff);
extern UINT16 u2HDMI2GetDigBaseAddr(HdmiRxPort ePort);
extern UINT16 u2HDMI2GetAnaBaseAddr(HdmiRxPort ePort);
extern UINT8 u1HDMI2_Get5VStatus(HdmiRxPort ePort);
extern void vHDMI2PortSel(HdmiRxPort ePort,UINT8 u1Type);
extern void vHDMI2PllSel(HdmiRxPort ePort,UINT8 u1Type);
extern BOOL bHDMI2IsSupport6G(HdmiRxPort ePort);
extern UINT8 u1HDMI2GetMhlPortId(void);
extern UINT32 u4GetHdmi2RegBase(HdmiRxPort ePort);
extern UINT32 u4GetHdmi2AnalogRegBase(HdmiRxPort ePort);
extern void vHDMI2SetStateMachine(HdmiRxPort ePort,UINT8 u1HdmiSta);
extern UINT8 bHDMI2GetStateMachine(HdmiRxPort ePort);
extern void vHDMI2StopFw(HdmiRxPort ePort);
extern void vHDMI2ResumeFw(HdmiRxPort ePort);
extern UINT8 u1HDMI2IsUnplug(HdmiRxPort ePort);
extern void vHDMI2ClrUnplug(HdmiRxPort ePort);
extern void vHDMI2SetUnplug(HdmiRxPort ePort);
extern UINT8 u1HDMI2IsHpdPulse(HdmiRxPort ePort);
extern void vHDMI2SetHpdPulse(HdmiRxPort ePort,UINT8 u1Val);
extern UINT8 u1HDMI2IsSyncLose(HdmiRxPort ePort);
extern void vHDMI2SetSyncLose(HdmiRxPort ePort,UINT8 u1Val);
extern void vHDMI2EQCIRCUITCTRL(HdmiRxPort ePort,BOOL bOnOff);
extern BOOL fgHDMI2GetDuleMode(HdmiRxPort ePort);
extern BOOL fgHDMI2SignalPresent(HdmiRxPort ePort);
extern BOOL fgHDMI2Get420Mode(HdmiRxPort ePort);
extern void vHDMI2SetSplit(HdmiRxPort eHdmiPort, UINT8 u1En);
extern BOOL fgHDMI2IsPixelRepeate(HdmiRxPort ePort);
extern UINT8 bHDMI2AudStatus(void);
extern BOOL fgHDMI2IsPCM(HdmiRxPort ePort);
extern UINT8 bHDMI2InputType(HdmiRxPort ePort);
extern UINT8 bHDMI2Clocrimetry(HdmiRxPort ePort);
extern UINT8 bGetHDMIRangeMode(void);
extern void vSetHDMIRangeMode(UINT8 bMode);
extern HdmiRxBitDepth_t bHDMI2DeepColorStatus(HdmiRxPort ePort);
extern BOOL fgHDMISupportAudio(void);
extern UINT8 bHDMI2RgbRange(HdmiRxPort ePort);
extern void vHDMI2AudStatusSet(HdmiRxPort ePort,UINT8 u1On);
extern UINT8 bHDMI2AudBitWidth(HdmiRxPort ePort);
extern UINT8 u1HDMI2GetAudioSamplingFreq(void);
extern UINT8 bHDMI2ScanInfo(HdmiRxPort eHdmiPort);
extern UINT8 bHDMI2AspectRatio(HdmiRxPort eHdmiPort);
extern UINT8 bHDMI2AFD(HdmiRxPort eHdmiPort);
extern UINT8 bHDMI2422Input(HdmiRxPort eHdmiPort);
extern UINT8 bHDMI2ITCFlag(HdmiRxPort eHdmiPort);
extern UINT8 bHDMI2ITCContent(HdmiRxPort eHdmiPort);
extern UINT8 bHDMIHDCP1StatusGet(HdmiRxPort eHdmiPort);
extern UINT8 bHDMIHDCP2StatusGet(HdmiRxPort eHdmiPort);
extern UINT8 bHDMI2GetInfoFrameToIF(HdmiRxPort eHdmiPort,HdmiRxInfo_t *ptInfo,UINT8 u1Type);
extern UINT8 u1HDMI2GetUPStatus(HdmiRxPort eHdmiPort);
extern UINT8 u1HDMI2GetUPStaChg(HdmiRxPort eHdmiPort);
extern UINT8 u1HDMI2Get4KPStatus(HdmiRxPort eHdmiPort);
extern void vHDMI2SetAcpChgCallback(DRIVER_HDMI_ACP_CHG_CB pfAcpChgCb,void *tag);
extern UINT8 u1HDMI2GetHdrEOTF(HdmiRxPort eHdmiPort);
extern void vHDMI2GetHdrMetaData(HdmiRxPort eHdmiPort,HDMI_HDR_METADATA *prHdrMetadata);
#ifdef __MODEL_slt__
extern BOOL bHDMI2SltCRCSample(HdmiRxPort eHdmiPort);
extern BOOL bHDMI2SltCRCCheck(HdmiRxPort eHdmiPort);
#endif
extern void vHDMI2PrintHdcp14Status(HdmiRxPort eHdmiPort);
extern void vHDMI2PrintHdcp22Status(HdmiRxPort eHdmiPort);
extern void vHDMI2PrintHdmiGeneralStatus(HdmiRxPort eHdmiPort);
extern void vHDMI2PrintHdmiVideoStatus(HdmiRxPort eHdmiPort);
extern void vHDMI2PrintHdmiAudioStatus(HdmiRxPort eHdmiPort);
extern void vHDMI2PrintHdmiStatus(HdmiRxPort eHdmiPort);
extern void vHDMI2ClrStableStatus(HdmiRxPort ePort);
extern UINT8 u1IsHDMI2Stable(HdmiRxPort ePort);
extern void vHDMI2PhyReset(HdmiRxPort ePort, UINT8 resettype);
extern void vHDMI2VideoMute(HdmiRxPort ePort,UINT8 u1En);
extern void HDMI2_pm_suspend(void);
extern void HDMI2_pm_resume(void);
extern void vHDMISpdifOutEnable(BOOL fgEnable);
extern void vSetHdmi2FastSw(HdmiRxPort ePort, UINT8 u1Val);
extern UINT8 u1IsHdmi2FastSw(HdmiRxPort ePort);
extern UINT32 u4HDMI2GetCurrentTmdsClkKhz(HdmiRxPort ePort);
extern HdmiTmdsClkRate_t bHDMI2GetRefClkRate(HdmiRxPort ePort);
extern UINT32 u4HDMI2GetBitRate(HdmiRxPort ePort);
extern void vHDMISetSwitch(HdmiRxPort eSwitch,UINT8 u1Type);
extern HdmiRxClrSpc_t eHDMI2GetHdmiClrSpc(HdmiRxPort eHdmiPort);
extern UINT8 bHDMI2GetHdmiMode(HdmiRxPort eHdmiPort);
extern void vHDMI2AudChannelStatus(HdmiRxPort ePort, BOOL *pfgCopyright, UINT8 *pu1CategoryCode,
                           UINT8 *p1WordLength, BOOL *pfgIsPcm);
#if defined(CC_S_PLATFORM)&&defined(CC_PHX_CUST)  //sony unicorn 4K
extern HdmiRxPort eHDMICurrSwitch ;
#endif
extern UINT8 bHDMI2GetAudChannelNum(HdmiRxPort ePort);
extern BOOL fgHDMI2AudioPCWMode(void);
extern UINT8 u1HDMIHDCPKeyCheckValid(HDMI_HDCP_KEY_CHECK_MODE_T eHdcpKeyCheckMode);
extern UINT32 u4HDMI2GetTmdsClkKhz(HdmiRxPort ePort);
extern MhlTmdsClkRate_t bMHL2GetRefClkRate(UINT32 u4ClkKhz);
//Customized functions defined in mtk_hdmi.h >>> BEGIN
#ifdef CC_HDMI_PORTID_PHY_VIR_MAPPING
extern void vHDMIPortInfoInit(void);
extern void vHDMIGetPortsInfo(HDMI_PORTS_INFO_T* prPortsInfo);
extern E_HDMI_SWITCH_NUM eHDMIGetPhysicalPortId(E_HDMI_SWITCH_NUM eVirPort);
extern E_HDMI_SWITCH_NUM eHDMIGetVirtualPortId(E_HDMI_SWITCH_NUM ePhyPort);
#endif//CC_HDMI_PORTID_PHY_VIR_MAPPING
#ifdef CC_HDMI_POH_SUPPORT
extern void vHDMIPohConfigInit(void);
extern BOOL fgHDMIPohEnabled(E_HDMI_SWITCH_NUM ePort);
extern void vHDMIGetPohConfig(E_HDMI_SWITCH_NUM ePort,HDMI_POH_CONFIG_T *prPohConfig);
#endif
//Customized functions defined in mtk_hdmi.h >>> END
#endif

