/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
 * Description: network configuration functions
 *---------------------------------------------------------------------------*/
#ifndef X_NET_CONFIG_H
#define X_NET_CONFIG_H

#include "u_common.h"
#include "u_net_common.h"
#include "u_net_oid.h"


#ifdef LINUX_TURNKEY_SOLUTION
#include <netinet/in.h>
#endif


#include "u_dhcpc_api.h"

extern INT32 x_net_network_init(VOID);
extern BOOL x_net_network_check_init(VOID);
extern INT32 x_net_network_deinit(VOID);
extern INT32 x_net_get_if_type (VOID);
extern VOID  x_net_ip_reg_cli(VOID);
extern INT32 x_net_get_dev_num(VOID);
extern INT32 x_net_ip_config(CHAR *psz_name, UINT32 ui4_address, UINT32 ui4_netmask, UINT32 ui4_gw);
extern INT32 x_net_dns_config(UINT32 ui4_dns1, UINT32 ui4_dns2);
extern VOID  x_net_set_hostname(CHAR *ps_hostname);

extern INT32 x_dhcpc_start (CHAR *ps_ni_name, x_dhcpc_nfy_fct fn);
extern INT32 x_dhcpc_stop(CHAR *ps_ni_name);
extern INT32 x_dhcpc_restart(CHAR *ps_ni_name);
extern INT32 x_dhcpc_get_info(CHAR *ps_ni_name, MT_DHCP4_INFO_T *pt_info);

extern INT32 x_net_disable (VOID);
extern INT32 x_net_enable (VOID);

extern INT32 x_net_network_ready (VOID *pv_arg);



extern INT32 x_net_ip_v6_config(CHAR *psz_name, UINT32 ui4_prefix_len, CHAR* pt_ipv6_addr, CHAR* pt_ipv6_gw);
extern INT32 x_net_dns_v6_config(CHAR* pc_dns1, CHAR* pc_dns2);
extern INT32 x_net_ip_v6_auto(CHAR *ps_ni_name, BOOL b_enable, BOOL b_restart_if);
extern INT32 x_net_ip_v6_disable(const CHAR *ps_ni_name);
extern INT32 x_net_ip_v6_dhcp(CHAR *ps_ni_name, BOOL b_enable, INT32 dhcp_type);
extern INT32 x_net_dns_v6_auto(CHAR *ps_ni_name, BOOL b_enable);
extern VOID x_net_ping_v6(CHAR * ps_ip,
                          INT32  i4_len,
                          INT16  i2_wait,
                          VOID (*notify_fn) (INT16 i2_rsp_time));
extern INT32 x_net_is_network_connect_v6(CHAR *ps_url);

extern INT32 x_net_get_v6_info(const CHAR* ps_ni_name, MT_IPV6_INFO_T* pt_info);

extern INT32 x_net_network_reg_nfy_ipv6(x_network_status_nfy pf_nfy, UINT32 ui4_tag, NET_IPV6_MODE_T e_mode);

extern INT32 x_net_set_prefer_v6(BOOL enable);
extern INT32 x_net_ni_rmv6config_all(char* dev);


extern char** x_net_dns_lookup2(const char* hostname, int family, int* size);
extern INT32 x_net_tcp_connect_test(const CHAR *url, int family, int port);

#endif
